//////////////////////////////////////////////////////////////////////////
//                                                                      //
// macros6405.asm -                                                     //
//                                                                      //
//                  //
//		nm6405,    .                          //
//                                                                      //
//		 : ,      //
//		,     ,  						//
//		   .								//
//                                                                      //
// Copyright (c) 2007-2008 RC Module                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 2     $      $Date::  $								//
//                                                                      //
//////////////////////////////////////////////////////////////////////////

//	     nm6405
macro PR_05_GUARD( instr )
.align;
instr;
instr;
end PR_05_GUARD;

//	  , 

macro ASSIGN_LEMA( const_or_reg )
	PR_05_GUARD( lema = const_or_reg );
end ASSIGN_LEMA;

macro ASSIGN_GEMA( const_or_reg )
	PR_05_GUARD( gema = const_or_reg );
end ASSIGN_GEMA;

macro ASSIGN_LIMA( const_or_reg )
	PR_05_GUARD( lima = const_or_reg );
end ASSIGN_LIMA;

macro ASSIGN_GIMA( const_or_reg )
	PR_05_GUARD( gima = const_or_reg );
end ASSIGN_GIMA;

macro ASSIGN_IOP( const_or_reg )
	PR_05_GUARD( iop = const_or_reg );
end ASSIGN_IOP;

macro SET_IOP( const_or_reg )
	PR_05_GUARD( iop set const_or_reg );
end SET_IOP;

macro CLEAR_IOP( const_or_reg )
	PR_05_GUARD( iop clear const_or_reg );
end CLEAR_IOP;

macro ASSIGN_IOPCR( const_or_reg )
	PR_05_GUARD( iopcr = const_or_reg );
end ASSIGN_IOPCR;

macro ASSIGN_DMAC0( const_or_reg )
	PR_05_GUARD( dmac0 = const_or_reg );
end ASSIGN_DMAC0;

macro ASSIGN_DMAC1( const_or_reg )
	PR_05_GUARD( dmac1 = const_or_reg );
end ASSIGN_DMAC1;

macro ASSIGN_T0( const_or_reg )
	PR_05_GUARD( t0 = const_or_reg );
end ASSIGN_T0;

macro ASSIGN_T1( const_or_reg )
	PR_05_GUARD( t1 = const_or_reg );
end ASSIGN_T1;

macro ASSIGN_IMR( const_or_reg )
	PR_05_GUARD( imr = const_or_reg );
end ASSIGN_IMR;

macro SET_IMR( const_or_reg )
	PR_05_GUARD( imr set const_or_reg );
end SET_IMR;

macro CLEAR_IMR( const_or_reg )
	PR_05_GUARD( imr clear const_or_reg );
end CLEAR_IMR;

macro CLEAR_IRR( const_or_reg )
	PR_05_GUARD( irr clear const_or_reg );
end CLEAR_IRR;

//	  , 

macro ASSIGN_OCA0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( oca0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_OCA0;

macro ASSIGN_ICA0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( ica0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_ICA0;

macro ASSIGN_OCA1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( oca1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_OCA1;

macro ASSIGN_ICA1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( ica1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_ICA1;

macro ASSIGN_GPA( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( gpa = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_GPA;

macro ASSIGN_OCC0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( occ0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_OCC0;

macro ASSIGN_ICC0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( icc0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_ICC0;

macro ASSIGN_OCC1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( occ1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_OCC1;

macro ASSIGN_ICC1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( icc1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_ICC1;

macro ASSIGN_LMCR0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( lmcr0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_LMCR0;

macro ASSIGN_LMCR1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( lmcr1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_LMCR1;

macro ASSIGN_GMCR0( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( gmcr0 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_GMCR0;

macro ASSIGN_GMCR1( const_or_reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( gmcr1 = const_or_reg );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end ASSIGN_GMCR1;

//	  , 

macro GET_LEMA( reg )
	PR_05_GUARD( reg = lema );
end GET_LEMA;

macro GET_GEMA( reg )
	PR_05_GUARD( reg = gema );
end GET_GEMA;

macro GET_LIMA( reg )
	PR_05_GUARD( reg = lima );
end GET_LIMA;

macro GET_GIMA( reg )
	PR_05_GUARD( reg = gima );
end GET_GIMA;

macro GET_IOP( reg )
	PR_05_GUARD( reg = iop );
end GET_IOP;

macro GET_IOPCR( reg )
	PR_05_GUARD( reg = iopcr );
end GET_IOPCR;

macro GET_DMAC0( reg )
	PR_05_GUARD( reg = dmac0 );
end GET_DMAC0;

macro GET_DMAC1( reg )
	PR_05_GUARD( reg = dmac1 );
end GET_DMAC1;

macro GET_T0( reg )
	PR_05_GUARD( reg = t0 );
end GET_T0;

macro GET_T1( reg )
	PR_05_GUARD( reg = t1 );
end GET_T1;

macro GET_IMR( reg )
	PR_05_GUARD( reg = imr );
end GET_IMR;

macro GET_IRR( reg )
	PR_05_GUARD( reg = irr );
end GET_IRR;

//	  , 

macro GET_OCA0( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = oca0 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_OCA0;

macro GET_ICA0( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = ica0 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_ICA0;

macro GET_OCA1( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = oca1 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_OCA1;

macro GET_ICA1( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = ica1 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_ICA1;

macro GET_GPA( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = gpa );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_GPA;

macro GET_OCC0( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = occ0 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_OCC0;

macro GET_ICC0( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = icc0 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_ICC0;

macro GET_OCC1( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = occ1 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_OCC1;

macro GET_ICC1( reg )
	pswr set 0000_0000_0000_0000_0000_0010_0000_0000b;
	PR_05_GUARD( reg = icc1 );
	pswr clear 0000_0000_0000_0000_0000_0010_0000_0000b;
end GET_ICC1;

