//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                          ftoi32.asm                                      //
//                                                                          //
//        32          //
//       32 .                                //
// ConvFtoI32 -  float     .                  //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .

global ConvFtoI32 :label;

extern LShift32         :label;
extern RShift32         :label;
extern FPIEEE_Signal    :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  ConvFtoI32 ==========================
//       32 
//       32 
//  : gr7 -  float  32 
//  : gr7 -  ,   32 
// : ar5
<ConvFtoI32>
    push ar0,gr0		with gr0 = gr7 << 1;
    push ar1,gr1		with gr0 >>= 24;     // 
    gr1 = 127;
    gr1 = 255			with gr0 - gr1;
    if u< skip Zero		with gr0 - gr1;     //   0       
    if =0 skip Abnormal;
    push ar2,gr2		with gr1 = gr7 << 9;
    gr2 = 00800000h		with gr1 >>= 9;
    gr2 = 23 + 127		with gr1 += gr2;
    gr0 -= gr2;
    if u>= skip Large;
    // cond. skip Large

        //     RShift32
    delayed call RShift32;
    push gr1 with gr0 = -gr0;
    push gr0 with gr0 = gr7;     //  
    // call RShift32

    delayed skip Res;
    pop ar2,gr2;
    nul;
    // skip Res;

<Large>
    gr2 = 8;
    with gr0 - gr2;
    if u>= delayed skip PreAbnormal;
    pop ar2,gr2;
    nul;
    // cond. skip Abnormal

        //     LShift32
    delayed call LShift32;
    push gr1;
    push gr0 with gr0 = gr7;
    // call LShift32

<Res>
    pop ar1,gr1
        with gr0;
    pop ar0,gr0;
    if >= return;
    return
        with gr7 = -gr7;

<Zero>
    pop ar1,gr1;
    pop ar0,gr0;
    return
        with gr7 = false;

<PreAbnormal>
	gr0 = 0CF000000h;
	with gr0 - gr7;
	if <>0 delayed skip Abnormal;
	gr7 = 80000000h;
    // cond. skip Abnormal
    pop ar1,gr1;
    pop ar0,gr0;
	return;

<Abnormal>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    pop ar1,gr1;
    pop ar0,gr0;
    return
        with gr7 = false;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                        ftoi32.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
