//    
//        
//       

const CP1I = 02000000h;  //       1
const ICH1 = 01000000h;  //      1
const OCH1 = 00800000h;  //      1
const CP0I = 00400000h;  //       0
const ICH0 = 00200000h;  //      0
const OCH0 = 00100000h;  //      0

global _CpPrgrmInit   : label;
global _CpFrstWordInit: label;
global _CpInHalt      : label;
global _CpInRelease   : label;
global _CpOutHalt     : label;
global _CpOutRelease  : label;
global _CpSendMsg     : label;
global _CpReceiveMsg  : label;
global _GetCpInCount  : label;
global _GetCpOutCount : label;

begin ".text"


//------------------------------------------
// size_t CpPrgrmInit ( int ch_no );
//     ch_no ( 64- 
//        )  
// 

    <_CpPrgrmInit>
        ar5 = ar7 - 2;
        gr7 = [--ar5];  // gr7 = ch_no
        gr7;
        if =0 goto _Cp0PrgrmInit;  //   0

    <_Cp1PrgrmInit>
        gr7 = pswr;
        pswr clear CP1I;  //    
                          //    1
        return;

    <_Cp0PrgrmInit>
        gr7 = pswr;
        pswr clear CP0I;  //    
                          //    0
        return;

//------------------------------------------
// size_t CpFrstWordInit ( int ch_no );
//     ch_no ( 64- 
//        )  
//   

    <_CpFrstWordInit>
        ar5 = ar7 - 2;
        gr7 = [--ar5];  // gr7 = ch_no
        gr7;
        if =0 goto _Cp0FrstWordInit;  //   0

    <_Cp1FrstWordInit>
        gr7 = pswr;
        pswr set CP1I;  //    
                        //    1
        return;

    <_Cp0FrstWordInit>
        gr7 = pswr;
        pswr set CP0I;  //    
                        //    0
        return;

//------------------------------------------
// size_t CpInHalt ( int ch_no );
//     ch_no

    <_CpInHalt>
        push ar6,gr6;
        ar6 = ar7 - 5;
        gr7 = [ar6];  // gr7 = ch_no
        pop ar6,gr6 with gr7;
        if =0 goto _Cp0InHalt;  //   0

    <_Cp1InHalt>
        gr7 = pswr;
        pswr set ICH1;  //       1
        return;

    <_Cp0InHalt>
        gr7 = pswr;
        pswr set ICH0;  //       0
        return;

//------------------------------------------
// size_t CpInRelease ( int ch_no );
//      ch_no

    <_CpInRelease>
        push ar6,gr6;
        ar6 = ar7 - 5;
        gr7 = [ar6];  // gr7 = ch_no
        pop ar6,gr6 with gr7;
        if =0 goto _Cp0InRelease;  //   0

    <_Cp1InRelease>
        gr7 = pswr;
        pswr clear ICH1;  //       1
        return;

    <_Cp0InRelease>
        gr7 = pswr;
        pswr clear ICH0;  //       0
        return;

//------------------------------------------
// size_t CpOutHalt ( int ch_no );
//     ch_no

    <_CpOutHalt>
        push ar6,gr6;
        ar6 = ar7 - 5;
        gr7 = [ar6];  // gr7 = ch_no
        pop ar6,gr6 with gr7;
        if =0 goto _Cp0OutHalt;  //   0

    <_Cp1OutHalt>
        gr7 = pswr;
        pswr set OCH1;  //       1
        return;

    <_Cp0OutHalt>
        gr7 = pswr;
        pswr set OCH0;  //       0
        return;

//------------------------------------------
// size_t CpOutRelease ( int ch_no );
//      ch_no

    <_CpOutRelease>
        push ar6,gr6;
        ar6 = ar7 - 5;
        gr7 = [ar6];  // gr7 = ch_no
        pop ar6,gr6 with gr7;
        if =0 goto _Cp0OutRelease;  //   0

    <_Cp1OutRelease>
        gr7 = pswr;
        pswr clear OCH1;  //       1
        return;

    <_Cp0OutRelease>
        gr7 = pswr;
        pswr clear OCH0;  //       0
        return;

//------------------------------------------
// void CpSendMsg ( int ch_no, size_t BufSize, void * BufAddr );
//  BufSize 64-    BufAddr   ch_no

    <_CpSendMsg>
        ar5 = ar7 - 2;
        gr7 = [ --ar5 ];  // gr6 = ch_no
        gr7;
        if =0 goto _Cp0SendMsg;  //   0

    <_Cp1SendMsg>
        push ar6,gr6;
        gr6 = [ --ar5 ];        // gr6 = BufSize
        ar6 = [ --ar5 ] with gr6 = -gr6;    // ar6 = BufAddr, gr6 = -BufSize
        oca1,occ1 = ar6,gr6;    // Cp1OutAddr      1
                                // Cp1OutCount     1

            //      1.
            // -   NM6403  1 
            //    .    
<wait_cp1_send>
        gr6 = occ1;
        with gr6;
        if <>0 goto wait_cp1_send;

        pop ar6,gr6;
        return;

    <_Cp0SendMsg>
        push ar6,gr6;
        gr6 = [ --ar5 ];        // gr6 = BufSize
        ar6 = [ --ar5 ] with gr6 = -gr6;    // ar6 = BufAddr, gr6 = -BufSize
        oca0,occ0 = ar6,gr6;    // Cp0OutAddr      0
                                // Cp0OutCount     0
        pop ar6,gr6;
        return;

//------------------------------------------
// void CpReceiveMsg ( int ch_no, size_t BufSize, void * BufAddr);
//  BufSize 64-    BufAddr   ch_no

    <_CpReceiveMsg>
        ar5 = ar7 - 2;
        gr7 = [ --ar5 ];  // gr6 = ch_no
        gr7;
        if =0 goto _Cp0ReceiveMsg;  //   0

    <_Cp1ReceiveMsg>
        push ar6,gr6;
        gr6 = [ --ar5 ];        // gr6 = BufSize
        ar6 = [ --ar5 ] with gr6 = -gr6;    // ar6 = BufAddr, gr6 = -BufSize
        ica1,icc1 = ar6,gr6;    // Cp1InAddr      1
                                // Cp1InCount     1

            //      1.
            // -   NM6403  1 
            //    .    
<wait_cp1_recv>
        gr6 = icc1;
        with gr6;
        if <>0 goto wait_cp1_recv;
        pop ar6,gr6;
        return;

    <_Cp0ReceiveMsg>
        push ar6,gr6;
        gr6 = [ --ar5 ];        // gr6 = BufSize
        ar6 = [ --ar5 ] with gr6 = -gr6;    // ar6 = BufAddr, gr6 = -BufSize
        ica0,icc0 = ar6,gr6;    // Cp0InAddr      0
                                // Cp0InCount     0
        pop ar6,gr6;
        return;

//------------------------------------------
// size_t GetCpInCount ( int ch_no );
//        ch_no

    <_GetCpInCount>
        ar5 = ar7 - 2;
        gr7 = [ --ar5 ];  // gr7 = ch_no
        gr7;
        if =0 goto _GetCp0InCount;  //   0

    <_GetCp1InCount>
        gr7 = icc1;
        return with gr7 = - gr7;

    <_GetCp0InCount>
        gr7 = icc0;
        return with gr7 = - gr7;

//------------------------------------------
// size_t GetCpOutCount ( int ch_no );
//        ch_no

    <_GetCpOutCount>
        ar5 = ar7 - 2;
        gr7 = [ --ar5 ];  // gr7 = ch_no
        gr7;
        if =0 goto _GetCp0OutCount;  //   0

    <_GetCp1OutCount>
        gr7 = occ1;
        return with gr7 = -gr7;

    <_GetCp0OutCount>
        gr7 = occ0;
        return with gr7 = - gr7;
end ".text";
