

	// Function declaration.
global _SendArrayCom0 : label;
global _SendArrayCom1 : label;
global _ReceiveArrayCom0 : label;
global _ReceiveArrayCom1 : label;

global _GetInCounterCom0 : label;
global _GetInCounterCom1 : label;
global _GetOutCounterCom0 : label;
global _GetOutCounterCom1 : label;

global _ResetComs : label;

import from macros640x;
import from macros6405;


begin ".text"

<_GetInCounterCom0>
	REG_WINDOW1();
	PR_05_GUARD( gr7 = icc0 );
delayed return with gr7 = -gr7;     
	REG_WINDOW0();

<_GetInCounterCom1>
	REG_WINDOW1();
	PR_05_GUARD( gr7 = icc1 );
delayed return with gr7 = -gr7;     
	REG_WINDOW0();

<_GetOutCounterCom0>
	REG_WINDOW1();
	PR_05_GUARD( gr7 = occ0 );
delayed return with gr7 = -gr7;     
	REG_WINDOW0();

<_GetOutCounterCom1>
	REG_WINDOW1();
	PR_05_GUARD( gr7 = occ1 );
delayed return with gr7 = -gr7;     
	REG_WINDOW0();


<_ResetComs>
	COM0_OUT_DISABLE();		//	 
	COM1_OUT_DISABLE();
	COM0_IN_DISABLE();
	COM1_IN_DISABLE();
	push ar0, gr0;					//  
	gr7 = intr_nmc3;
	gr0 = 2dh with gr7 <<= 26;
	gr7 >>= 26;
	pop ar0, gr0 with gr0 - gr7;	//	   -?
	if < goto finWithInters;
	
	intr_nmc3 clear 40h;					//	
	
<finWithInters>
	REG_WINDOW1();				//	window == 1 !!!
	gr7 = false;			//   
.align;	
	occ0 = gr7;
	occ1 = gr7;
	icc0 = gr7;
	icc1 = gr7;
	REG_WINDOW0();				//	end window == 1
return;     

<BadEnd>
delayed return with gr7 = false;    
	REG_WINDOW0();				//	end window == 1

<_SendArrayCom0>
	REG_WINDOW1();				//	window == 1 !!!
	PR_05_GUARD( gr7 = occ0 );
	with gr7;
	if <>0 goto BadEnd;
	gr7 = [ar7-3];    
	PR_05_GUARD( oca0 = gr7 );
	gr7 = [ar7-4];    
	gr7 = -gr7;
	gr7 C>>= 1;
	if carry goto BadEnd with gr7 <<= 1;
	PR_05_GUARD( occ0 = gr7 );
	COM0_OUT_ENABLE();
	gr7 = 1;
<sac0end>
delayed return;    
	REG_WINDOW0();				//	end window == 1

<_SendArrayCom1>
	REG_WINDOW1();				//	window == 1 !!!
	PR_05_GUARD( gr7 = occ1 );
	with gr7;
	if <>0 goto BadEnd;
	gr7 = [ar7-3];    
	PR_05_GUARD( oca1 = gr7 );
	gr7 = [ar7-4];    
	gr7 = -gr7;
	gr7 C>>= 1;
	if carry goto BadEnd with gr7 <<= 1;
	PR_05_GUARD( occ1 = gr7 );
	COM1_OUT_ENABLE();
	gr7 = 1;
<sac1end>
delayed return;    
	REG_WINDOW0();				//	end window == 1

<_ReceiveArrayCom0>
	REG_WINDOW1();				//	window == 1 !!!
	PR_05_GUARD( gr7 = icc0 );
	with gr7;
	if <>0 goto BadEnd;
	gr7 = [ar7-3];  
	PR_05_GUARD( ica0 = gr7 );
	gr7 = [ar7-4];  
	gr7 = -gr7;
	gr7 C>>= 1;
	if carry goto BadEnd with gr7 <<= 1;
	PR_05_GUARD( icc0 = gr7 );
	COM0_IN_ENABLE();
	gr7 = 1;
<rec0end>
delayed return;     
	REG_WINDOW0();				//	end window == 1

<_ReceiveArrayCom1>
	REG_WINDOW1();				//	window == 1 !!!
	PR_05_GUARD( gr7 = icc1 );
	with gr7;
	if <>0 goto BadEnd;
	gr7 = [ar7-3];  
	PR_05_GUARD( ica1 = gr7 );
	gr7 = [ar7-4];  
	gr7 = -gr7;
	gr7 C>>= 1;
	if carry goto BadEnd with gr7 <<= 1;
	PR_05_GUARD( icc1 = gr7 );
	COM1_IN_ENABLE();
	gr7 = 1;
<rec1end>
delayed return;     
	REG_WINDOW0();				//	end window == 1


end ".text";
