//----------------------------------------------------------------------//
//                                                                      //
//                     Neuroprocessor NM6403 SDK v. 1.20                //
//                                                                      //
//                              Demo program                            //
//             that exchange arrays with NM6403 on board.               //
//                        NM6403 part of program.                       //
//                                                                      //
//                 1998 (c) RC Module Inc., Moscow, Russia              //
//                                                                      //
//----------------------------------------------------------------------//

#include "nc_load.h"

typedef unsigned int WORD32;

const WORD32 Length = 0x1000;
WORD32 AddrStore[ Length ];
WORD32 AddrLoad[ Length ];

int main()
{
    WORD32 Fill = 1;

        // initial fill
    for ( int i = 0; i < Length; i++ ) {
        AddrStore[i] = Fill;
    }

    ncl_hostSyncArray( 1, AddrStore, Length, NULL, NULL );

    while(1) {
        if ( ncl_hostSyncArray( 2, AddrLoad, Length, NULL, NULL ) == 17 )
            break;

            // time for host work.

        if ( ncl_hostSync( 3 ) == 17 )
            break;

        for ( int i = 0; i < Length; i++ ) {
            AddrStore[i] = AddrLoad[i];
        }

    }

    return 0;
}
